//+------------------------------------------------------------------+
//|                                                   VOM_manual.mqh |
//|                                     Copyright Paul Hampton-Smith |
//|                            http://paulsfxrandomwalk.blogspot.com |
//+------------------------------------------------------------------+

/** \mainpage    Virtual Order Manager

<b> 1.  </b> \n
,       MetaTrader 4  MetaTrader 5     
    \e  .             
,            .
     FIFO NFA 2-43(b),      .\n

    ,    ,    ,  
   .       ,   
  , ,  ,      , 
   .     MetaTrader 4        
         (),   MetaTrader 5    .\n

 ,        ,     
  ,   MetaTrader 4.     MetaTrader 4   ,
          ,      
           .\n\n

<b> 2.  Virtual Order Manager </b> \n
 VOM     .mqh,      Experts\\Virtual Order Manager:
- ChartObjectsTradeLines.mqh - CEntryPriceLine, CStopLossLine, CTakeProfitLine
- StringUtilities.mqh -    ,   ErrorDescription()
- Log.mqh - CLog
- GlobalVirtualStopList.mqh - CGlobalVirtualStopList
- SimpleChartObject.mqh - CButton, CLabel and CEdit
- VirtualOrder.mqh - CVirtualOrder
- GlobalVariable.mqh - CGlobalVariable
- VirtualOrderArray.mqh - CVirtualOrderArray
- VirtualOrderManager.mqh - CVirtualOrderManager
- VirtualOrderManagerConfig.mqh - CConfig
- VirtualOrderManagerEnums.mqh -  ,   VOM
- VOM_manual.mqh -   

Four EA mq5 files are also included under Experts\\Virtual Order Manager\\VOM EAs:
- VOM_template_EA.mq5 - clone this to make your own EAs, and store them in Experts\\Virtual Order Manager
- VirtualOrderManagerTester.mq5
- Support_Resistance_EA_VOM.mq5
- FrAMA_Cross_EA_VOM.mq5

 
- VOM-doc.chm

<b> 3.  Virtual Order Manager   </b>\n

Virtual Order Manager      MQL5,    ,   
     MQL4,     ,   
  .\n   

   ,     VOM,   . 1.
\image html Slide1.png " 1.   Virtual Order Manager"
\n
    VOM   . 2.

\image html Slide2.png " 2.    Virtual Order Manager"
\n
<b>    2 </b>\n\n
- \code #include "VirtualOrderManager.mqh" \endcode \n
       VOM      
CVirtualOrderManager VOM;\n\n
- OnInit()\n
      ,     . 
  VOM,   OnInit()    : 
\code
// EA code
void OnInit()\n
{
	// The System ID or Magic Number is calculated from the EA name
	//  ID  Magic Number     
	VOM.Initialise();
	//
  //  ,     
  // ....
}
\endcode \n\n

- OnTick()\n
 MQL5     start()  MQL4.
 ,  VOM    ,    ,   OnTick() 
     :
\code
// EA code
void OnTick()
{
	// action virtual stoplosses, takeprofits and pending orders
	//     SL, TP   
	VOM.OnTick();
	//    
   Comment(VOM.m_OpenOrders.SummaryList());
	//
	//       OnTick   
	// ....
}
\endcode \n\n
- <b>   </b> \n
         MQL4.\n
  MQL4     :
\code OrderSend(symbol,type,volume,price,slippage,sl,tp,"comment",0); \endcode
  VOM     :
\code VOM.OrderSend(symbol,type,volume,price,slippage,sl,tp,"comment",0); \endcode \n
 ,     , .     CVirtualOrderManager.\n\n

<b> 4.  Virtual Order Manager </b> \n
 . 3     VOM.
\image html Slide3.png " 3.  VOM"
- \b Configuration -          VOM   
 Config  CConfig.          public (),  
  / .\n
 
- <b> Global variables </b> -   ,         MQL5,
    GlobalVariableGet(). Virtual Order Manager      :
              CGlobalVariable;
        -  ,    ,   .\n

 - <b> Open trades and history files </b> -     ,   CVirtualOrderArrays  , 
         .        
 Files\\VOM   ,  VOM.  CVirtualOrder      VOM.m_OpenOrders
           VOM.m_OrderHistory.\n

 - <b> Activity and debug log </b> -         ,
       CLog.           ,
              .\n\n

 
<b> 5.  Virtual Order Manager </b> \n
       ,     VirtualOrderManagerTester.mq5
  , ,         .\n
 . 4,  ,      buy 0.1    sell 0.3     EURUSD.
   short,   ""     sell  0.2 ,   . 
   ,    DPSL,  ,   50    .
      ,  , ,      \n

\image html VOM1.GIF " 4.  VOM"

<b> 6. Running real EAs on the Virtual Order Manager </b> \n
  VOM -     ,    .
    VOM,     : \n
- ,   ,            
- ,    Fractal Adaptive Moving Average (FrAMA)   .\n

<b> 7.    VOM </b> \n
     -  - Virtual Order Manager,    MetaTrader 5, 
  ,    VOM ,          MQL5.\n

,     , ,     MQL5 Community  :\n
-           , ,   .
-       , ,    MetaTrader 5
   ,          .\n
-     MetaTrader 5 Beta      .\n
-        . \n 
-      :\n
	- GetLastError() and ErrorDescription() functions.
	-          .
	-     .
	-     .
	
\n\n\n
<b>  </b> \n
- V0.1  
- V0.2   2  .  VOM_template_EA.mq5  
- V0.3 7/2/10
	-   VOM            Files\\VOM
	-           / 
	-     CVirtualOrderManager::Buy, CVirtualOrderManager::Sell  CVirtualOrderManager::NewBar()
- V0.4 9/2/10
	-              
	-   Magic Number
	-    CLog
	-   10     CLog::Log
- V0.5 14/2/10
	- fixed order errors caused by conversion of ulong magic to int
	- general audit of type integrity through function calls
- V0.6 29/3/10
   -         
   -      -      


   
*/